<template>
	<div class="mod-config">
		<el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
			<el-form-item>
				<el-input v-model="dataForm.key" placeholder="产品编号/产品名称" clearable></el-input>
			</el-form-item>
			<el-form-item>
				<el-button @click="getDataList()">查询</el-button>
				<!-- <el-button @click="addOrEdit()">测试</el-button> -->
				<!-- <el-button v-if="$hasPermission('monitoring:product:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button> -->
				<el-button v-if="$hasPermission('monitoring:product:save')" type="primary" @click="addOrEdit()">新增</el-button>
			</el-form-item>
		</el-form>

		<base-table :data="dataList" :table-head-configs="tableConfigs" :max-height="500" @operate-event="handleOperations" @refreshDataList="getDataList" />

		<el-pagination
			@size-change="sizeChangeHandle"
			@current-change="currentChangeHandle"
			:current-page="pageIndex"
			:page-sizes="[10, 20, 50, 100]"
			:page-size="pageSize"
			:total="totalPage"
			layout="total, sizes, prev, pager, next, jumper"
		></el-pagination>
		<!-- 弹窗, 新增 / 修改 -->
		<!-- <add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getDataList"></add-or-update> -->

		<base-dialog v-if="showbasedialog" ref="basedialog" :configs="addOrUpdateConfigs" @refreshDataList="getDataList" @destory-dialog="showbasedialog = false" />
	</div>
</template>

<script>
import { calcMaxHeight } from '@/utils'
// import AddOrUpdate from './product-add-or-update'
import BaseTable from '@/components/base-table'
import TableOperateComponent from '@/components/base-table/components/operationComponent'
// import TableTextComponent from '@/components/base-table/components/detailComponent'
import BaseDialog from '@/components/base-dialog/addOrUpdate'
import moment from 'moment'
import dictListMixin from '@/mixins/dictlist-module'
import { dictFilter } from '@/utils/filters'

const UnitDictTypeId = '1557173812109242370'
const ProductTypeDictTypeId = '1557179530308616193'
const tableConfigs = [
	{ type: 'index', name: '序号' },
	{ prop: 'createTime', name: '添加时间', filter: val => (val ? moment(val).format('YYYY-MM-DD hh:mm:ss') : '-') },
	{ prop: 'name', name: '产品名称' },
	{ prop: 'code', name: '产品编码' },
	{ prop: 'specifications', name: '规格' },
	{ prop: 'unitDictValue', name: '单位', filter: dictFilter(UnitDictTypeId) },
	{ prop: 'operations', name: '操作', fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['viewAttr', 'delete'] }
]

const addOrUpdateConfigs = {
	type: 'dialog', // dialog | drawer | page
	infoUrl: '/monitoring/product',
	fields: [
		'name',
		{
			name: 'code',
			api: '/monitoring/product/getCode'
		},
		{
			name: 'processTime',
			label: '加工时间',
			placeholder: '请输入加工时间',
			type: 'number',
			required: true,
			rules: [
				{
					type: 'number',
					trigger: 'blur',
					transform: val => Number(val),
					message: '必须输入数字'
				}
			]
		},
		{
			name: 'typeDictValue',
			label: '产品类型', // 对于非常见属性，最好自己指定label
			type: 'select',
			options: [
				// 动态获取
			]
		},
		{
			name: 'unitDictValue',
			label: '单位',
			type: 'select',
			// placeholder: '请选择单位',
			options: [
				// 动态获取
			]
		},
		{
			name: 'area',
			label: '单位平方数',
			type: 'number',
			rules: [{ type: 'number', transform: val => Number(val), message: '请输入数字', trigger: 'blur' }]
		},
		'specifications',
		'remark'
	],
	operations: [
		{ name: 'cancel', url: true, showAlways: true },
		{ name: 'save', url: '/monitoring/product', permission: '', showOnEdit: false },
		{ name: 'update', url: '/monitoring/product', permission: '', showOnEdit: true }
	],
	subtable: {
		// for i18n
		title: '动态属性',
		url: '/monitoring/productArrt',
		relatedField: 'productId',
		tableConfigs: [
			{ type: 'index', name: '序号' },
			{ prop: 'createTime', name: '添加时间', filter: val => (val ? moment(val).format('YYYY-MM-DD hh:mm:ss') : '-') },
			{ prop: 'name', name: '属性名', formField: true, rules: [{ required: true, message: '必填', trigger: 'blur' }] },
			{ prop: 'code', name: '属性值', formField: true },
			{ prop: 'operations', name: '操作', fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['edit', 'delete'] }
		]
	}
}

export default {
	mixins: [dictListMixin],
	data() {
		return {
			calcMaxHeight,
			tableConfigs,
			dataForm: {
				key: ''
			},
			dataList: [],
			pageIndex: 1,
			pageSize: 10,
			totalPage: 0,
			dataListLoading: false,
			dataListSelections: [],
			addOrUpdateVisible: false,
			addOrUpdateConfigs,
			showbasedialog: false
		}
	},
	components: {
		// AddOrUpdate,
		BaseTable,
		BaseDialog
	},
	created() {
		this.initDictList([UnitDictTypeId, ProductTypeDictTypeId])
		this.addOrUpdateConfigs.fields.forEach(item => {
			if (item.name) {
				if (item.name === 'typeDictValue') {
					item.options = this.dictList[ProductTypeDictTypeId]
				} else if (item.name === 'unitDictValue') {
					item.options = this.dictList[UnitDictTypeId]
				}
			}
		})
	},
	activated() {
		this.getDataList()
	},
	methods: {
		//
		addOrEdit(id) {
			this.showbasedialog = true
			this.$nextTick(() => {
				this.$refs.basedialog.init(id)
			})
		},
		// 获取数据列表
		getDataList() {
			// console.log("after dialog close: ", this.showbasedialog)
			this.showbasedialog = false // 清理弹窗
			this.dataListLoading = true
			this.$http({
				url: this.$http.adornUrl('/monitoring/product/page'),
				method: 'get',
				params: this.$http.adornParams({
					page: this.pageIndex,
					limit: this.pageSize,
					key: this.dataForm.key
				})
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.dataList = data.data.list
					this.totalPage = data.data.total
				} else {
					this.dataList = []
					this.totalPage = 0
				}
				this.dataListLoading = false
			})
		},
		// 每页数
		sizeChangeHandle(val) {
			this.pageSize = val
			this.pageIndex = 1
			this.getDataList()
		},
		// 当前页
		currentChangeHandle(val) {
			this.pageIndex = val
			this.getDataList()
		},
		// 多选
		selectionChangeHandle(val) {
			this.dataListSelections = val
		},
		// 新增 / 修改
		addOrUpdateHandle(id) {
			this.addOrUpdateVisible = true
			this.$nextTick(() => {
				this.$refs.addOrUpdate.init(id)
			})
		},
		// 表格操作事件管理
		handleOperations({ type, data }) {
			switch (type) {
				case 'viewAttr': // <== 对照 tableConfig
					return this.addOrEdit(data)
				case 'delete':
					return this.deleteHandle(data)
			}
		},
		// 删除
		deleteHandle(id) {
			console.log('id is: ', id)
			var ids = id
				? [id]
				: // ? [1556817256347828335]
				  this.dataListSelections.map(item => {
						return item.id
				  })
			this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '删除' : '批量删除'}]操作?`, '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then(() => {
				this.$http({
					url: this.$http.adornUrl('/monitoring/product'),
					method: 'delete',
					data: ids
					// or : data: this.$http.adornData(ids, false, 'raw')
				})
					// or: this.$http.delete(this.$http.adornUrl('/monitoring/product'), { data: this.$http.adornData(ids, false) })
					.then(({ data }) => {
						if (data && data.code === 0) {
							this.$message({
								message: '操作成功',
								type: 'success',
								duration: 1500,
								onClose: () => {
									this.getDataList()
								}
							})
						} else {
							this.$message.error(data.msg)
						}
					})
			})
		}
	}
}
</script>
